/*
 * File: IsPrime1.c
 *
 * This file contains the implementation of the function IsPrime1.
 * 
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 */

#include "IsPrime1.h"



/*
 * Function: IsPrime1
 * Usage: if ( IsPrime1(n) )
 * -------------------------
 */

bool IsPrime1(int n)
{
  int k, kmax;

  /* compute ceil(n/2) and assign it to kmax */
  kmax = n / 2;
  if ( n % 2 == 1 ) {
    kmax++;
  }

  for (k = 2; k <= kmax; k++) {
    if ( n % k == 0 ) { return FALSE; }
  }

  return TRUE;
}

