/*
 * File: IsPrime2.h
 * ----------------
 * 
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 */

#ifndef ISPRIME2_H
#define ISPRIME2_H

#include "genlib.h"

/*
 * Function: IsPrime2
 * Usage: if ( IsPrime2(n) )
 * -------------------------
 * The function IsPrime2 computes whether the given number of prime or
 * not.
 *
 * IsPrime2 works as follows: given an integer n, we first check
 * whether n is 2 or another enven number. If this is the case the
 * appropriate result is returned. Then for each odd integer k from 3 to
 * ceil(n/2) compute the remainder of the division of n with
 * k. If a zero remainder is found return that the number is prime,
 * otherwise return that the number is not prime.
 */

bool IsPrime2(int n);

#endif /* ISPRIME2_H */
