/*
 * File: IsPrime3.c
 *
 * This file contains the implementation of the function IsPrime3.
 * 
 * Author: M. I. Karavelas
 * Class:  EM101 / Fall Semester 2008
 */

#include "IsPrime3.h"
#include <math.h>


/*
 * Function: IsPrime3
 * Usage: if ( IsPrime3(n) )
 * -------------------------
 */

bool IsPrime3(int n)
{
  int k, kmax;
  double sqrt_n;

  if ( n == 2 ) { return TRUE; }
  if ( n % 2 == 0 ) { return FALSE; }

  /* compute ceil(sqrt(n)) and assign it to kmax */
  sqrt_n = sqrt((double)n);
  if ( ((int)sqrt_n) == sqrt_n ) {
    kmax = sqrt_n;
  } else {
    kmax = (int)sqrt_n + 1;
  }

  for (k = 3; k <= kmax; k += 2) {
    if ( n % k == 0 ) { return FALSE; }
  }

  return TRUE;
}
